/*   
     
Chess-Ec    Copyright (C)   2001-2008 Marc Dechico


 ec_branche.h: Memorize the subsequants move used to get the best move.
   
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

To contact the author:	Marc Dechico
Kerfring
29390 SCAER France
tel: 06 37 98 22 54
Mail: ec@chess-ec.org  

*/
#include "ec_global.h"
#ifdef UPLOAD_BRANCHE

/****************************************************/
/* external data */
/****************************************************/

/* profondeur de simulation 		*/
extern int         i_pro_sim_act;             	

/****************************************************/
/* external function */
/****************************************************/


/* These function to free alocated memmory */ 
extern  int mem_lst_ini (struct st_ind **pst_ind);
extern  int mem_lst_add (struct st_ind **pst_ind, void * p_new_bloc);
extern  int mem_lst_fre (struct st_ind **pst_ind);
extern  void * mem_malloc ( unsigned int size);
/* traduit type mvt en type  piece*/
extern char pro_pio_tra_tmvt_lpie (int i_typ_mvt);
/****************************************************/
/* local data */
/****************************************************/

struct st_branche st_branche; 
/****************************************************/
/* local function */
/****************************************************/

int bra_ini_mem              (long li_ini_nod_qua,int c_inc_per);
int bra_fre_mem              (void);
int bra_add_nod_max_inf      (struct st_bra_nod **ppst_bra_nod_hea,
			      struct st_bra_nod **ppst_bra_nod_las,
			      char * c_pos_ori_n, char * c_pos_n, char *c_typ_mvt); 
int bra_add_nod              (struct st_bra_nod **ppst_bra_nod_hea,
	 	              struct st_bra_nod **ppst_bra_nod_tai,
			      struct st_bra_nod **ppst_bra_nod_las_p,
			      struct st_bra_nod **ppst_bra_nod_las,
			      char * c_pos_ori_n, char * c_pos_n, char *c_typ_mvt);
int bra_rem_nod              (struct st_bra_nod **ppst_bra_nod_hea,
			      struct st_bra_nod **ppst_bra_nod_las_p,
			      struct st_bra_nod **ppst_bra_nod_las);

int bra_prt_lst(struct st_bra_nod *pst_bra_nod_lst);


static int bra_inc_mem(void);
static int bra_get_nxt_nod (void);


#endif
