/*
    
    Chess-Ec     Copyright (C)   2001-2008 Marc Dechico

    ec_eva.c :  compute the datas collected during the simulation 
                (exploration of the game tree) 
		automat to find bugs in the engine (play random)
		automat to compare methode of evaluation 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  
    
*/
#include "ec_eva.h"


/************************************************************************/
/* function */
/************************************************************************/
int  new_evaluation(struct st_evaluation **ppst_eva)
{

  // pointer of pointer used for future dynamic memory allocation
  // argument must be adresse of a struc st_eva 
  // exemple for now: 
  // struct st_evaluation pst_eva; 
  // new_evaluation(& pst_eva);

  // for the moment using a global structure 
  *ppst_eva=&st_evaluation;
  if (*ppst_eva == NULL) return -1;

  // initialisation of the module eva
  (*ppst_eva)->i_number_of_initial_move=0;
  //  (*ppst_eva)->ts_not_mvt_ini=ts_not_mvt_ini;
  //(*ppst_eva)->tst_hst_pro_sta=tst_pro_sta;
  //st_evaluation.ts_not_mvt_ini=ts_not_mvt_ini;
  //st_evaluation.tst_pro_sta_=tst_pro_sta;
  (*ppst_eva)->i_best_move_nbr=0;
  return 0;
}
int free_evaluation(struct st_evaluation **ppst_eva)
{
  return 0;
}
/* simulation pour evaluation meilleur mouvement */
int  simul_eva(int i_pro_sim_niv_wrk,	
	       int i_pro_sim_inc_wrk)
{
  int i_msg;
  struct timeval a1,a2;
  gettimeofday(&a1,NULL);
  //printf("\nfirst pass: 4,0 ");
  i_msg = simul(4,
		0,
		USE_HASH_NO,
		INI_MVT_INI_YES,
		INI_RAP_FOR_YES,
		not_cal,
		ts_hst_pro[i_pro_act].i_cam);
  gettimeofday(&a2,NULL);
  //printf("\n Elapsed Time used in millisecond: %li", diff_time_ms(a2,a1));
  // mvt_ini is initialized and feed with datas 
  // but datas need to be computed before being visualized
  // finding the best move should not be done at this level
  // shoud separate eva_mei_mvt  in two functions:
  //    -- data processing for further use  
  //    -- making final choice
  pst_evaluation->i_best_move_nbr=eva_mei_mvt();

  defv_aff_not_pos = Y;  

  if (i_msg<0)
    {
      //defv_aff_not_pos = N;
      return i_msg;


    }

  else
    {
#ifdef ALWAYS_STATS

      aff_not_2(pst_evaluation);
#endif
      /*      
      i_msg= find_positive_sure_not(ts_not_mvt_ini,i_not_cpt_mvt_ini);
       if (i_msg>=0)
	{
	  pst_evaluation->i_best_move_nbr= i_msg;
	  return i_msg;
	}
      */
    }
  //gettimeofday(&a1,NULL);		
  i_msg = simul(i_pro_sim_niv_wrk,
		i_pro_sim_inc_wrk,
		USE_HASH_YES,
		INI_MVT_INI_NO,
		INI_RAP_FOR_YES,
		not_cal_deep,
		ts_hst_pro[i_pro_act].i_cam);
		


  gettimeofday(&a2,NULL);
  printf("Time:%li ms", diff_time_ms(a2,a1));

  if (i_msg>=0)
    {
      defv_aff_not_pos = Y; /* affichaoge de la note possible */
      i_msg=eva_mei_mvt();
      pst_evaluation->i_best_move_nbr=i_msg;
      return  i_msg;
    }
  else
    {
      defv_aff_not_pos = N;
    }
  return i_msg;
}

int find_positive_sure_not(ST_NOT_MVT_INI *pts_mvt_ini,int i_not_cpt_mvt_ini)
{
  int cpt_mvt;
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++) 
    {

      if (
	  pts_mvt_ini->i_not_pri >=FOR_CAV
	  &&
	  pts_mvt_ini->i_typ_mvt_pri_lea==0
	  )
	  
  
	return cpt_mvt;
      else
	pts_mvt_ini++;
    }
  return -1;
}

/* simul et joue  */
int sim_jou(void)
{
  int i_msg;

  /* org essayer de ne pas faire référence à ts_not_mvt_ini */ 
  i_msg=simul_eva(i_pro_sim_niv,i_pro_sim_inc); /* recherche du meilleur mouvement */
  if (i_msg>=0) /* si pas deja mat ou pat */
    {
      // debug: need to see
#ifdef ALWAYS_STATS
      aff_not_2(pst_evaluation);
#endif
      i_msg=jou(
		ts_not_mvt_ini[i_msg].i_pos_ori_n,
		ts_not_mvt_ini[i_msg].i_pos_arr_n,
		pro_pio_tra_tmvt_tpie(ts_not_mvt_ini[i_msg].i_typ_mvt)
		);
 
      if ( i_msg ==0 ) /* si pas d'erreur pendant mouvement toujours vrai!?*/
	{	i_msg=simul_ctl();  /* controle si mat pat */
	sav_dsk("ec.wrk");
	} 
    }

  return i_msg;

}

int sim_jou_sel(void)
{
  /* use the special function simul_eva_sel that make a first preselection
     of of moves that are supposed to have the best potential */
  int i_msg;
  /* org essayer de ne pas faire référence à ts_not_mvt_ini */ 
  i_msg=simul_eva_sel(i_pro_sim_niv,i_pro_sim_inc); /* recherche du meilleur mouvement */
  if (i_msg>=0) /* si pas deja mat ou pat */
    {
      i_msg=jou(
		ts_not_mvt_ini[i_msg].i_pos_ori_n,
		ts_not_mvt_ini[i_msg].i_pos_arr_n,
		pro_pio_tra_tmvt_tpie(ts_not_mvt_ini[i_msg].i_typ_mvt)
		);
 
      if ( i_msg ==0 ) /* si pas d'erreur pendant mouvement toujours vrai!?*/
	{	i_msg=simul_ctl();  /* controle si mat pat */
	sav_dsk("ec.wrk");
	} 
    }

  return i_msg;

}
/* simulation pour evaluation meilleur mouvement */
int  simul_eva_sel(int i_pro_sim_niv_wrk,	
		   int i_pro_sim_inc_wrk)
{
  enum e_sit_typ_not_pos e_sit_typ;
  /* determine le type de situation */
  if (i_pro_act <10)
    e_sit_typ=opn_gam;
  else
   e_sit_typ=mid_gam;

  /*
    return the "best move" 
    makes a preselection with a low deepness (level 3.1)
    order the moves 
    take these ordered moves one by one and
    simul again at a higher deepness 
    stop when out of time or when finding a good move  
    
  */
  //  extern int i_mei_mvt;	/* N° du meilleur mvt */
  //extern int   aff_not_1(int * pi_mei_mvt);
  int i_msg;
  int i_not_cpt_mvt_ini_sv;
  struct timeval a1,a2;
  gettimeofday(&a1,NULL);
  /* collect data for a first  selection */
  i_msg = simul(3,3,
		USE_HASH_YES,
		INI_MVT_INI_YES, 
		INI_RAP_FOR_YES,
		not_cal,
		pts_hst_pro->i_cam);

  /* compute data and order the initial move */
  i_msg=eva_mei_mvt();
  defv_aff_not_pos = Y; /* affichaoge de la note possible */
  //aff_not_1(&i_mei_mvt);

  i_not_cpt_mvt_ini_sv=i_not_cpt_mvt_ini;

  /* do no copute again if note ok */
  /* should add a test on the number of repetition (allready known )*/
  if(
     ts_tri_mvt_ini[0].pts_tri_rec->i_not_pri>=0
     &&
     ts_tri_mvt_ini[0].pts_tri_rec->i_typ_mvt_pri_lea==0
     )
  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega(e_sit_typ);

  /* take the sorted move one by one an make a deeper collection */
  int i;
  int i_fou_not_ok=0; /* found note positive */
  for (i=0;i<i_not_cpt_mvt_ini_sv;i++)
    {
      /* move the piece */
      i_msg = jou (
		   ts_tri_mvt_ini[i].pts_tri_rec->i_pos_ori_n,
		   ts_tri_mvt_ini[i].pts_tri_rec->i_pos_arr_n,
		   pro_pio_tra_tmvt_lpie (ts_tri_mvt_ini[i].pts_tri_rec->i_typ_mvt)
		   ) ;
      if(i_msg<0)
	{ 	
	  printf("\n%c:",pro_pio_tra_tmvt_lpie (ts_tri_mvt_ini[i].pts_tri_rec->i_typ_mvt));
	  printf(" %s",tc_lib_cas[ts_tri_mvt_ini[i].pts_tri_rec->i_pos_ori_n]);
	  printf("%s",tc_lib_cas[ts_tri_mvt_ini[i].pts_tri_rec->i_pos_arr_n]);
	  aff_mes_uti(i_msg);
	  return 0;
	}
      else
	{  
	  ts_hst_pro[i_pro_act].i_not_max=NOT_MIN;
	  printf("\napres jou not %i not max %i pri_leaf %i",
		 ts_hst_pro[i_pro_act].i_not,
		 ts_hst_pro[i_pro_act].i_not_max,
		 ts_hst_pro[i_pro_act].i_typ_mvt_pri_lea
		 );

	  /* recollect data but deeper */
	  i_msg = simul(3,4,
			USE_HASH_YES,
			INI_MVT_INI_NO,
			INI_RAP_FOR_NO,
			NULL,
			pts_hst_pro->i_cam_adv);
	  printf("\nrecalcul N°:%i   apres simul  not:%i not max:%i pri_leaf:%i",
		 i,
		 ts_hst_pro[i_pro_act].i_not,
		 ts_hst_pro[i_pro_act].i_not_max,
		 ts_hst_pro[i_pro_act].i_not_max_typ_mvt_pri_lea
		 );
	  /* update only the not in not_mvt_ini */  

	  ts_tri_mvt_ini[i].pts_tri_rec->i_not_pri=ts_hst_pro[i_pro_act].i_not_max;
	  ts_tri_mvt_ini[i].pts_tri_rec->i_typ_mvt_pri_lea
	    =
	    ts_hst_pro[i_pro_act].i_not_max_typ_mvt_pri_lea;
	  /* move back the piece */
	  ann_cou();   

	}
      extern char  defv_sto_sim_cla;
      if ( ts_tri_mvt_ini[i].pts_tri_rec->i_not_pri >= 0
	   &&
	   ts_tri_mvt_ini[i].pts_tri_rec->i_typ_mvt_pri_lea == 0
	   )
	i_fou_not_ok=1;

      if ((
	   i_fou_not_ok
	   &&
	   i>=1
	   /* two more sech are made because of the necessite to have an other solution */
	   /* when there is repetition causing equality */
	   )
	  ||
	  defv_sto_sim_cla==Y
	  ||
	  i>100  /* sould be testing on time */
	  )
	break;
    }

  
  gettimeofday(&a2,NULL);
  printf("\n Elapsed Time used in millisecond: %li", diff_time_ms(a2,a1));

    tri_mvt_rec_2 ();

  if (i_msg>=0)
    {
      defv_aff_not_pos = Y; /* affichaoge de la note possible */
      //     i_msg=eva_mei_mvt();
      //aff_not_1(&i_mei_mvt);
    }
  else
    {
      defv_aff_not_pos = N;
    }
  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega(e_sit_typ);

}

void cho_coe_01 (void)
{
  
  st_eva_sit.ti_coe_pon[nbr_mvt]		=0;

  st_eva_sit.ti_coe_pon[nbr_mat]		=5;
  st_eva_sit.ti_coe_pon[nbr_mat_rf]		=10;
  st_eva_sit.ti_coe_pon[nbr_mat_inc]		=1;

  if (st_eva_sit.i_not_for < -230)
    {
      st_eva_sit.ti_coe_pon[nbr_pat]		=7;
      st_eva_sit.ti_coe_pon[nbr_pat_rf]		=15;
      st_eva_sit.ti_coe_pon[nbr_pat_inc]	=3;
    }
  else
  {
      st_eva_sit.ti_coe_pon[nbr_pat]		=0;
      st_eva_sit.ti_coe_pon[nbr_pat_rf]		=0;
      st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;
  }
  st_eva_sit.ti_coe_pon[mob_pie]		=3;
  st_eva_sit.ti_coe_pon[cou_pie]		=3;
  st_eva_sit.ti_coe_pon[nbr_fou]		=3;
  st_eva_sit.ti_coe_pon[pos_pie]		=5;

}
void cho_coe_02 (void)
{
  /*pourrait calculer directement coef à partir note situation */ 
  /* il faudrait mouliner et faire des statistiques pour vérifier */
  /* la véracité  des coef choisis */

  /* pour qu'une note soit prepodérante il faut que sont coef soit 
     superieur à la somme des coef des autre notes                */
  
  st_eva_sit.ti_coe_pon[nbr_mvt]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat]		=3;
  st_eva_sit.ti_coe_pon[nbr_pat]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat_rf]		=3;
  st_eva_sit.ti_coe_pon[nbr_pat_rf]		=0;
  st_eva_sit.ti_coe_pon[nbr_mat_inc]		=2;
  st_eva_sit.ti_coe_pon[nbr_pat_inc]		=0;
  st_eva_sit.ti_coe_pon[mob_pie]		=1;
  st_eva_sit.ti_coe_pon[cou_pie]		=0;
  st_eva_sit.ti_coe_pon[nbr_fou]		=0;

}
void cho_coe_03 (enum e_sit_typ_not_pos e_sit_typ)
{

  switch (e_sit_typ)
    {
    case opn_gam:
      { 
	st_eva_sit.ti_coe_pon[nbr_mvt]		=0;

	st_eva_sit.ti_coe_pon[nbr_mat]		=0;
	st_eva_sit.ti_coe_pon[nbr_mat_rf]	=0;
	st_eva_sit.ti_coe_pon[nbr_mat_inc]	=0;

	st_eva_sit.ti_coe_pon[nbr_pat]    	=0;
	st_eva_sit.ti_coe_pon[nbr_pat_rf]	=0;
	st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;

	st_eva_sit.ti_coe_pon[mob_pie]		=10;
	st_eva_sit.ti_coe_pon[cou_pie]		=5;
	st_eva_sit.ti_coe_pon[nbr_fou]		=5;
	st_eva_sit.ti_coe_pon[pos_pie]		=15;
      }
      break;
    default:
      { 
	st_eva_sit.ti_coe_pon[nbr_mvt]		=0;
	st_eva_sit.ti_coe_pon[nbr_mat]		=5;
	st_eva_sit.ti_coe_pon[nbr_mat_rf]	=5;
	st_eva_sit.ti_coe_pon[nbr_mat_inc]	=5;

	if (st_eva_sit.i_not_for < LIMIT_PAT)
	  {
	    st_eva_sit.ti_coe_pon[nbr_pat]	=7;
	    st_eva_sit.ti_coe_pon[nbr_pat_rf]	=15;
	    st_eva_sit.ti_coe_pon[nbr_pat_inc]	=3;
	  }
	else
	  {
	    st_eva_sit.ti_coe_pon[nbr_pat]	=0;
	    st_eva_sit.ti_coe_pon[nbr_pat_rf]	=0;
	    st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;
	  }
	st_eva_sit.ti_coe_pon[mob_pie]		=10;
	st_eva_sit.ti_coe_pon[cou_pie]		=3;
	st_eva_sit.ti_coe_pon[nbr_fou]		=15;
	st_eva_sit.ti_coe_pon[pos_pie]		=5;
      }
      break;
    }


}
void cho_coe_beg_01 (enum e_sit_typ_not_pos e_sit_typ)
{
  /* */
  switch (e_sit_typ)
    {
    case opn_gam:
      { 
	st_eva_sit.ti_coe_pon[nbr_mvt]		=0;

	st_eva_sit.ti_coe_pon[nbr_mat]		=0;
	st_eva_sit.ti_coe_pon[nbr_mat_rf]	=0;
	st_eva_sit.ti_coe_pon[nbr_mat_inc]	=0;

	st_eva_sit.ti_coe_pon[nbr_pat]    	=0;
	st_eva_sit.ti_coe_pon[nbr_pat_rf]	=0;
	st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;

	st_eva_sit.ti_coe_pon[mob_pie]		=2;
	st_eva_sit.ti_coe_pon[cou_pie]		=0;
	st_eva_sit.ti_coe_pon[nbr_fou]		=0;
	st_eva_sit.ti_coe_pon[pos_pie]		=5;
      }
      break;
    default:
      { 
	st_eva_sit.ti_coe_pon[nbr_mvt]		=0;
	st_eva_sit.ti_coe_pon[nbr_mat]		=-5;
	st_eva_sit.ti_coe_pon[nbr_mat_rf]	=-5;
	st_eva_sit.ti_coe_pon[nbr_mat_inc]	=-5;

	if (st_eva_sit.i_not_for < LIMIT_PAT)
	  {
	    st_eva_sit.ti_coe_pon[nbr_pat]	=7;
	    st_eva_sit.ti_coe_pon[nbr_pat_rf]	=15;
	    st_eva_sit.ti_coe_pon[nbr_pat_inc]	=3;
	  }
	else
	  {
	    st_eva_sit.ti_coe_pon[nbr_pat]	=0;
	    st_eva_sit.ti_coe_pon[nbr_pat_rf]	=0;
	    st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;
	  }
	st_eva_sit.ti_coe_pon[mob_pie]		=5;
	st_eva_sit.ti_coe_pon[cou_pie]		=-3;
	st_eva_sit.ti_coe_pon[nbr_fou]		=-15;
	st_eva_sit.ti_coe_pon[pos_pie]		=10;
      }
      break;
    }


}
void cho_coe_int_01 (enum e_sit_typ_not_pos e_sit_typ)
{
  /* */
  switch (e_sit_typ)
    {
    case opn_gam:
      { 
	st_eva_sit.ti_coe_pon[nbr_mvt]		=0;

	st_eva_sit.ti_coe_pon[nbr_mat]		=0;
	st_eva_sit.ti_coe_pon[nbr_mat_rf]	=0;
	st_eva_sit.ti_coe_pon[nbr_mat_inc]	=0;

	st_eva_sit.ti_coe_pon[nbr_pat]    	=0;
	st_eva_sit.ti_coe_pon[nbr_pat_rf]	=0;
	st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;

	st_eva_sit.ti_coe_pon[mob_pie]		=2;
	st_eva_sit.ti_coe_pon[cou_pie]		=0;
	st_eva_sit.ti_coe_pon[nbr_fou]		=0;
	st_eva_sit.ti_coe_pon[pos_pie]		=10;
      }
      break;
    default:
      { 
	st_eva_sit.ti_coe_pon[nbr_mvt]		=0;
	st_eva_sit.ti_coe_pon[nbr_mat]		=5;
	st_eva_sit.ti_coe_pon[nbr_mat_rf]	=10;
	st_eva_sit.ti_coe_pon[nbr_mat_inc]	=5;

	if (st_eva_sit.i_not_for < LIMIT_PAT)
	  {
	    st_eva_sit.ti_coe_pon[nbr_pat]	=7;
	    st_eva_sit.ti_coe_pon[nbr_pat_rf]	=15;
	    st_eva_sit.ti_coe_pon[nbr_pat_inc]	=3;
	  }
	else
	  {
	    st_eva_sit.ti_coe_pon[nbr_pat]	=0;
	    st_eva_sit.ti_coe_pon[nbr_pat_rf]	=0;
	    st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;
	  }
	st_eva_sit.ti_coe_pon[mob_pie]		=0;
	st_eva_sit.ti_coe_pon[cou_pie]		=0;
	st_eva_sit.ti_coe_pon[nbr_fou]		=10;
	st_eva_sit.ti_coe_pon[pos_pie]		=5;
      }
      break;
    }


}
void cho_coe_hig_01 (enum e_sit_typ_not_pos e_sit_typ)
{
  /* */
  switch (e_sit_typ)
    {
    case opn_gam:
      { 
	st_eva_sit.ti_coe_pon[nbr_mvt]		=0;

	st_eva_sit.ti_coe_pon[nbr_mat]		=0;
	st_eva_sit.ti_coe_pon[nbr_mat_rf]	=0;
	st_eva_sit.ti_coe_pon[nbr_mat_inc]	=0;

	st_eva_sit.ti_coe_pon[nbr_pat]    	=0;
	st_eva_sit.ti_coe_pon[nbr_pat_rf]	=0;
	st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;

	st_eva_sit.ti_coe_pon[mob_pie]		=2;
	st_eva_sit.ti_coe_pon[cou_pie]		=0;
	st_eva_sit.ti_coe_pon[nbr_fou]		=0;
	st_eva_sit.ti_coe_pon[pos_pie]		=10;
      }
      break;
    default:
      { 
	st_eva_sit.ti_coe_pon[nbr_mvt]		=0;
	st_eva_sit.ti_coe_pon[nbr_mat]		=3;
	st_eva_sit.ti_coe_pon[nbr_mat_rf]	=2;
	st_eva_sit.ti_coe_pon[nbr_mat_inc]	=1;

	if (st_eva_sit.i_not_for < LIMIT_PAT)
	  {
	    st_eva_sit.ti_coe_pon[nbr_pat]	=7;
	    st_eva_sit.ti_coe_pon[nbr_pat_rf]	=15;
	    st_eva_sit.ti_coe_pon[nbr_pat_inc]	=3;
	  }
	else
	  {
	    st_eva_sit.ti_coe_pon[nbr_pat]	=0;
	    st_eva_sit.ti_coe_pon[nbr_pat_rf]	=0;
	    st_eva_sit.ti_coe_pon[nbr_pat_inc]	=0;
	  }
	st_eva_sit.ti_coe_pon[mob_pie]		=3;
	st_eva_sit.ti_coe_pon[cou_pie]		=1;
	st_eva_sit.ti_coe_pon[nbr_fou]		=10;
	st_eva_sit.ti_coe_pon[pos_pie]		=5;
      }
      break;
    }


}
int  eva_mei_mvt(void)
{
  int i_mei_mvt;

  i_mei_mvt= (*pf_eva)();

  return i_mei_mvt;
}

int  eva_mei_mvt_00(void)
{
  enum e_sit_typ_not_pos e_sit_typ;
  /* determine le type de situation */
  if (i_pro_act <10)
    e_sit_typ=opn_gam;
  else
   e_sit_typ=mid_gam;
    
	
  /* traitement des donneés */
  tra_don (0);

  /* Choix coef de ondération */
  cho_coe_01();

  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega(e_sit_typ);

}

int  eva_mei_mvt_01(void)
{
  enum e_sit_typ_not_pos e_sit_typ;
  /* determine le type de situation */
  if (i_pro_act <10)
    e_sit_typ=opn_gam;
  else
   e_sit_typ=mid_gam;
    
	
   /* traitement des donneés */
  tra_don (0);

  /* Choix coef de ondération */
  cho_coe_02();

  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega(e_sit_typ);

}
int  eva_mei_mvt_02(void)
{	
  enum e_sit_typ_not_pos e_sit_typ;
  /* determine le type de situation */
  if (i_pro_act <10)
    e_sit_typ=opn_gam;
  else
   e_sit_typ=mid_gam;
    
  /* traitement des donneés */
  tra_don (e_sit_typ);

  /* Choix coef de ondération */
   cho_coe_03(e_sit_typ);

  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega(e_sit_typ);

}
int  eva_mei_mvt_beg_01(void)
{	
  enum e_sit_typ_not_pos e_sit_typ;
  /* determine le type de situation */
  if (i_pro_act <10)
    e_sit_typ=opn_gam;
  else
   e_sit_typ=mid_gam;
    
  /* traitement des donneés */
  tra_don (e_sit_typ);

  /* Choix coef de ondération */
   cho_coe_beg_01(e_sit_typ);


  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega(e_sit_typ);

}
int  eva_mei_mvt_int_01(void)
{	
  enum e_sit_typ_not_pos e_sit_typ;
  /* determine le type de situation */
  if (i_pro_act <6)
    e_sit_typ=opn_gam;
  else
   e_sit_typ=mid_gam;
    
  /* traitement des donneés */
  tra_don (e_sit_typ);

  /* Choix coef de ondération */
   cho_coe_int_01(e_sit_typ);


  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega(e_sit_typ);

}
int ver_ini (void)
{

  tst_ver[V00].pf_eva=eva_mei_mvt_00;
  tst_ver[V00].i_pro_sim_niv=3;
  tst_ver[V00].i_pro_sim_inc=2;
  tst_ver[V00].ptc_lib=_("V0");
  tst_ver[V00].i_ran_cho_max=RANDOM_CHOICE_MAX;
  if (tst_ver[V00].i_ran_cho_max >RANDOM_CHOICE_MAX)   tst_ver[V00].i_ran_cho_max=RANDOM_CHOICE_MAX;
 

  tst_ver[V01].pf_eva=eva_mei_mvt_01;
  tst_ver[V01].i_pro_sim_niv=3;
  tst_ver[V01].i_pro_sim_inc=2;
  tst_ver[V01].ptc_lib=_("V1");
  tst_ver[V01].i_ran_cho_max=RANDOM_CHOICE_MAX;
  if (tst_ver[V01].i_ran_cho_max >RANDOM_CHOICE_MAX)   tst_ver[V01].i_ran_cho_max=RANDOM_CHOICE_MAX;

  tst_ver[V02].pf_eva=eva_mei_mvt_02;
  tst_ver[V02].i_pro_sim_niv=3;
  tst_ver[V02].i_pro_sim_inc=2;
  tst_ver[V02].ptc_lib=_("V2");
  tst_ver[V02].i_ran_cho_max=RANDOM_CHOICE_MAX;
  if (tst_ver[V02].i_ran_cho_max >RANDOM_CHOICE_MAX)   tst_ver[V02].i_ran_cho_max=RANDOM_CHOICE_MAX;

  tst_ver[LOW1].pf_eva=eva_mei_mvt_beg_01;
  tst_ver[LOW1].i_pro_sim_niv=2;
  tst_ver[LOW1].i_pro_sim_inc=0;
  tst_ver[LOW1].ptc_lib=_("b1");
  tst_ver[LOW1].i_ran_cho_max=2;
  if (tst_ver[LOW1].i_ran_cho_max >RANDOM_CHOICE_MAX)   tst_ver[LOW1].i_ran_cho_max=RANDOM_CHOICE_MAX;

  tst_ver[MEDIUM1].pf_eva=eva_mei_mvt_int_01;
  tst_ver[MEDIUM1].i_pro_sim_niv=2;
  tst_ver[MEDIUM1].i_pro_sim_inc=4;
  tst_ver[MEDIUM1].ptc_lib=_("m1");
  tst_ver[MEDIUM1].i_ran_cho_max=2;
  if (tst_ver[MEDIUM1].i_ran_cho_max >RANDOM_CHOICE_MAX)   tst_ver[MEDIUM1].i_ran_cho_max=RANDOM_CHOICE_MAX;

  tst_ver[HIGH1].pf_eva=eva_mei_mvt_hig_01;
  tst_ver[HIGH1].i_pro_sim_niv=2;
  tst_ver[HIGH1].i_pro_sim_inc=10;
  tst_ver[HIGH1].ptc_lib=_("h1");
  tst_ver[HIGH1].i_ran_cho_max=2;
  if (tst_ver[HIGH1].i_ran_cho_max >RANDOM_CHOICE_MAX)   tst_ver[HIGH1].i_ran_cho_max=RANDOM_CHOICE_MAX;

  return 0;
}
int  eva_mei_mvt_hig_01(void)
{	
  enum e_sit_typ_not_pos e_sit_typ;
  /* determine le type de situation */
  if (i_pro_act <4)
    e_sit_typ=opn_gam;
  else
   e_sit_typ=mid_gam;
    
  /* traitement des donneés */
  tra_don (e_sit_typ);

  /* Choix coef de ondération */
   cho_coe_hig_01(e_sit_typ);


  /* pondération des données suivant l'importance accordée  pour calcul note globale */
  pon_not();

  /* Tri des données par not recadrée pondére */
  tri_mvt_rec();

  /* controle cas d'égalité du à reproduction pos piece */
  return ctl_ega(e_sit_typ);

}
void not_mvt_ini_raz(int i_pro_sim,int i_inc_pro_sim)
{
  int x,y;

  ST_NOT_MVT_INI *pts_mvt;

  enum typ_not tn;
  for(x=0;x<MVT_INI;x++)
    {
      pts_mvt = &ts_not_mvt_ini[x];
      /* org : shouldn't refer to hst */
      pts_mvt->i_cam		=pts_hst_pro->i_cam;
      pts_mvt->i_cam_adv	=pts_hst_pro->i_cam_adv;
      pts_mvt->i_pro_sim	=i_pro_sim;
      pts_mvt->i_inc_pro_sim	=i_inc_pro_sim;
      
      for(y=0; y<PRO_SIM_INF_MAX; y++)
      for (tn = 0; tn <NBR_TYP_NOT;tn++)
	{
	  /* remise a zero des cumuls provenant de hst et autres*/
	  pts_mvt->tst_not[tn].f_not_cam_bru[BLANC]=0;
	  pts_mvt->tst_not[tn].f_not_cam_bru[NOIR]=0;
	  pts_mvt->tst_not[tn].f_not_cam_pon[BLANC]=0;
	  pts_mvt->tst_not[tn].f_not_cam_pon[NOIR]=0;
	  pts_mvt->tst_not[tn].f_not_dif_pon=0;
	  pts_mvt->tst_not[tn].i_not_pon_rec=0;
	}

 	{
	  /* Remise à zero des infos collecté dans hst  pro*/
	  tst_pro_sta[x][y].i_cam=0;
	  tst_pro_sta[x][y].i_inc=0;
	  for (tn = 0; tn <NBR_TYP_NOT;tn++)
	    tst_pro_sta[x][y].f_dat_pro[tn]=0;

	}
    }
  /* raz valeur d'évaluation de la situation */
  st_eva_sit.ti_tot_for	[BLANC]	=0;
  st_eva_sit.ti_tot_for	[NOIR ]	=0;
  st_eva_sit.i_not_for		=0;

  st_eva_sit.tf_cou	[BLANC]	=0;
  st_eva_sit.tf_cou	[NOIR ]	=0;
  st_eva_sit.f_cou		=0;
  
  st_eva_sit.tf_mob	[BLANC]	=0;
  st_eva_sit.tf_mob	[NOIR ]	=0;
  st_eva_sit.f_not_mob		=0;
 
  for (tn = 0; tn <NBR_TYP_NOT;tn++)
    {
      st_eva_sit.ti_coe_pon[tn]		=0;
      st_eva_sit.tst_int_not[tn].max 	=0;
      st_eva_sit.tst_int_not[tn].min 	=0;
    }
}
void hst_cpt_raz(defv_bool defv_bool_hash,int i_cam_ene)
{
  int pro;
  int i_dec;
  // defv_bool defv_ene;
  /* opti: commencer à profondeur  actuelle */
   for(pro=i_pro_act+1;pro <= i_pro_sim_max_inf;pro++)
    {
      ts_hst_pro[pro].uli_cpt_mat	  =0;
      ts_hst_pro[pro].uli_cpt_pat	  =0;
      ts_hst_pro[pro].uli_cpt_mat_rf	  =0;
      ts_hst_pro[pro].uli_cpt_pat_rf	  =0;
      ts_hst_pro[pro].uli_nbr_fou	  =0;
      ts_hst_pro[pro].uli_cpt_cou  	  =0;
#ifdef STHASH1
      ts_hst_pro[pro].i_nbr_ele_tpf_hash =-1; 
      ts_hst_pro[pro].i_mem_hash_nbr     =-1;
      ts_hst_pro[pro].i_sto_res_hash_nbr =-1;
#endif
    }

  /* precalculation du rapport de force initial */
  /* pour eviter un accés tableau par le camp */ 
  /* rapport de force camp 0 = - rap de for camp 1 */
  /* opti : recalculé en fin de simu pour evaluation */

   /*
     i_big_adv 
    =
    eva_for_cam(ts_hst_pro[i_pro_act+1].i_cam)
    -
    eva_for_cam(ts_hst_pro[i_pro_act+1].i_cam_adv)
    - FOR_FOU 
    - FOR_TOU;
   */
  /* pour savoir si le camp en cours est l'adversaire dans la simulation  */
   //  defv_ene = N;
  i_dec=0;
  for (pro=i_pro_act+1;pro <= i_pro_sim_max_inf;pro++)   
    {
      /* qui est l'enemie */
      //      ts_hst_pro[pro].defv_ene = defv_ene;
      // if(defv_ene == Y)
      //	defv_ene = N;
      // else
      //	defv_ene = Y;
      if (ts_hst_pro[pro].i_cam==i_cam_ene)
	ts_hst_pro[pro].defv_ene = Y;
      else
	ts_hst_pro[pro].defv_ene = N;


      /* mise à jour du décrement de la note.
	 Plus le mat est proche de la base, moins la note mat sera  forte */
      ts_hst_pro[pro].i_dec_mat  = DEC_MAT  * ++i_dec;
#ifdef STHASH
      ts_hst_pro[pro].pf_hash_add_lx = NULL;
#endif      
    }
  if(defv_bool_hash)
    {
#ifdef STHASH
      ts_hst_pro[i_pro_act +1].pf_hash_add_lx = sim_add_l1;/*deprecated */
      ts_hst_pro[i_pro_act +2].pf_hash_add_lx = sim_add_l2;
      ts_hst_pro[i_pro_act +3].pf_hash_add_lx = sim_add_l3;
#endif
#ifdef STHASH1
      /* detemine the number of hash to use*/
      int i_depth=i_pro_sim_max_sup - i_pro_act;
      int i_inc=i_pro_sim_max_inf - i_pro_sim_max_sup;
      int i_nbr_hash=0;
      //printf("\nhst_init:depth %i inc %i",i_depth,i_inc);
           
      switch (i_depth)
	{
	case 2:
	  if (i_inc >=8){ i_nbr_hash=2;	  break; }
	  if (i_inc >=6){ i_nbr_hash=1;	  break; }
	  if (i_inc >=4){ i_nbr_hash=0;	  break; }
	  i_nbr_hash=0;	  break;
	case 3:
	  if (i_inc >=8){ i_nbr_hash=3;	  break; }
	  if (i_inc >=6){ i_nbr_hash=2;	  break; }
	  if (i_inc >=4){ i_nbr_hash=1;	  break; }
	  i_nbr_hash=0;	  break;
	case 4:
	  if (i_inc >=8){ i_nbr_hash=4;	  break; }
	  if (i_inc >=6){ i_nbr_hash=3;	  break; }
	  if (i_inc >=4){ i_nbr_hash=2;	  break; }
	  i_nbr_hash=1;break;
	  //	  if (i_inc >=4) i_nbr_hash=2; else i_nbr_hash=1;
	  // break;
	case 5:
	  if (i_inc >=8){ i_nbr_hash=5;	  break; }
	  if (i_inc >=6){ i_nbr_hash=4;	  break; }
	  if (i_inc >=4){ i_nbr_hash=3;	  break; }
	  i_nbr_hash=2;break;
	  //if (i_inc >=4) i_nbr_hash=3; else i_nbr_hash=2;
	  // break;
	case 6:
	  if (i_inc >=8){ i_nbr_hash=6;	  break; }
	  if (i_inc >=6){ i_nbr_hash=5;	  break; }
	  if (i_inc >=4){ i_nbr_hash=4;	  break; }
	  i_nbr_hash=3;break;

	  //if (i_inc >=4) i_nbr_hash=4; else i_nbr_hash=3;
	  //break;
	case 1:
	  /* should  never occur */
	  i_nbr_hash=0;break;
	default:
	  i_nbr_hash=NBR_MAX_HASH;
	}
      if (i_nbr_hash > NBR_MAX_HASH) i_nbr_hash=NBR_MAX_HASH;
      else 
	if (i_nbr_hash<0) i_nbr_hash=0;
      
      // printf("\nNbr_hash: %i ",i_nbr_hash);
      
      int i;
      for (i=0;i<i_nbr_hash;i++)
	{
	 
	  int x=i_pro_act +i;
	  int y;

	  y=++(ts_hst_pro[x+1].i_nbr_ele_tpf_hash); 
	  ts_hst_pro    [x+1].ti_arg_fct_hash_add[y]=i;
	  ts_hst_pro    [x+1].tpf_hash_add[y]=sim_add_l1;
	  ts_hst_pro    [x+1].i_mem_hash_nbr=i;

	  y=++(ts_hst_pro[x+2].i_nbr_ele_tpf_hash); 
	  ts_hst_pro    [x+2].ti_arg_fct_hash_add[y]=i;
	  ts_hst_pro    [x+2].tpf_hash_add[y]=sim_add_l2;

	  y=++(ts_hst_pro[x+3].i_nbr_ele_tpf_hash); 
	  ts_hst_pro    [x+3].ti_arg_fct_hash_add[y]=i;
	  ts_hst_pro    [x+3].tpf_hash_add[y]=sim_add_l3;

	  ts_hst_pro    [x+4].i_sto_res_hash_nbr=i;

	} 

#endif      

    }
}


void not_cal (void)
{
  /* Stockage des données dans structure du mvt initial                     */

  struct st_pie		*pts_pie_cal;	/* ptr tableau struct pièce */
  ST_NOT_MVT_INI *pts_mvt;
   int x,y; 				/* index pour transfert de nbr coups */
  /* de hst dans not mvt ini */ 
  int inc;
  pts_mvt = &ts_not_mvt_ini[i_not_cpt_mvt_ini];
   
  /* memorise le numéro de mvt */
  pts_mvt->i_num_mvt =i_not_cpt_mvt_ini;

  /* memorise l'Id */
  pts_mvt->i_Id = pts_hst_pro_p->i_Id;

  /* memorise le type du mouvement */
  pts_mvt->i_typ_mvt =  pts_hst_pro_p->i_typ_mvt;
  /* memorise si mvt  de prise  */
  pts_mvt->i_typ_mvt_pri =  ti_typ_mvt_pri[pts_hst_pro_p->i_typ_mvt];
  
  /* memorise la position de depart */
  pts_mvt->i_pos_ori_n = pts_hst_pro_p->i_pos_ori_n;

  /* memorise la position d'arrivée */
  pts_mvt->i_pos_arr_n =  pts_hst_pro_p->i_pos_n;
  
  /* initialisation des pionteurs sur  pie */
  pts_pie_cal = pts_hst_pro_p->pts_pie_pc + pts_hst_pro_p->i_Id;

  /* memorise le libelle */
  pts_mvt->c_lib_pie = pts_pie_cal->c_lib_pie;

  /* memorise de la note  */
  pts_mvt->i_not_pri = pts_hst_pro_p->i_not;

  /* and the type of move at leaf (1 = taken) */
  pts_mvt->i_typ_mvt_pri_lea= pts_hst_pro_p->i_typ_mvt_pri_lea;

#ifdef UPLOAD_BRANCHE  
  /* save the head of the liste of move (branche  for  not_max) */
  pts_mvt->pst_bra_nod=pts_hst_pro->pst_not_max_bra_hea;
#endif
  /* Stockage des infos de hst dans mvt ini pour retraitement ulterieur */
  for(x=i_pro_sim_act,y=0; x<=i_pro_sim_max_inf; x++,y++)
    {
      /* Memorisation du camp */
      tst_pro_sta[i_not_cpt_mvt_ini][y].i_cam =ts_hst_pro[x].i_cam;
		
      /* Memorisation si increment  */
      if  (x>i_pro_sim_max_sup)
	inc=1;
      else
	inc =0;
      tst_pro_sta[i_not_cpt_mvt_ini][y].i_inc = inc;

      /* transfert nombre de mvt */
 
       tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mvt] 		
	=
	ts_hst_pro[x].uli_cpt_cou;

      ts_hst_pro[x].uli_cpt_cou = 0;
		
      /* transfert npmbre de mat */

      if(inc == 0)	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_mat;
      else	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat_inc] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_mat;

      ts_hst_pro[x].uli_cpt_mat = 0;
		
      /* transfert npmbre de pat */
      if(inc == 0 )	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat;
      else
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat_inc] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat;

      ts_hst_pro[x].uli_cpt_pat = 0;
	
      /* transfert npmbre de mat raport de force >=0 */

      if(inc == 0 )	
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_mat_rf] 	 		
	  =	
	  ts_hst_pro[x].uli_cpt_mat_rf;

      ts_hst_pro[x].uli_cpt_mat_rf = 0;
		
      /* transfert npmbre de pat rapoort de force >=0 */
      if(inc == 0)	 
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_pat_rf] 	 		
	  =
	  ts_hst_pro[x].uli_cpt_pat_rf;
      ts_hst_pro[x].uli_cpt_pat_rf = 0;

      /* transfert nombre de fourchette  */
		if(inc == 0)
	 tst_pro_sta[i_not_cpt_mvt_ini][y].f_dat_pro[nbr_fou] 	 		
	  =
	  ts_hst_pro[x].uli_nbr_fou;
      ts_hst_pro[x].uli_nbr_fou  = 0;
	
    }
 
  //  if	(
  //	 i_pro_sim_max_sup!= i_pro_act+2
  //	 ||
  //	 i_pro_sim_max_inf!= i_pro_act+2
  //	 )
    {
      aff_cal_en_cou(i_not_cpt_mvt_ini,2);
  /*test*/
    /*aff_ech(0);aff_pie(0);*/

    }
  
  /* interuption de la simulation si mat detecté */
  if (pts_hst_pro_p->defv_mat == Y) sto_sim();

  /* increment du compteur de mouvement */
  pst_evaluation-> i_number_of_initial_move++; 
  //transfert in pie_sui
}

void not_cal_sel (void)
{
 
  if	(
	 i_pro_sim_max_sup!= i_pro_act+2
	 ||
	 i_pro_sim_max_inf!= i_pro_act+2
	 )
    {
      aff_cal_en_cou(i_not_cpt_mvt_ini,1);
  /*test*/
    /*aff_ech(0);aff_pie(0);*/

    }
  
  /* interuption de la simulation si mat detecté */
  if (pts_hst_pro_p->defv_mat == Y) sto_sim();

  /* increment du compteur de mouvement */
  // i_not_cpt_mvt_ini++;
  //transfert in pie_sui
  

}

void not_cal_deep (void)
{
  ST_NOT_MVT_INI *pts_mvt;
  pts_mvt = &ts_not_mvt_ini[i_not_cpt_mvt_ini];
   
    /* memorise de la note  */
  pts_mvt->i_not_pri = pts_hst_pro_p->i_not;

  /* and the type of move at leaf (1 = taken) */
  pts_mvt->i_typ_mvt_pri_lea= pts_hst_pro_p->i_typ_mvt_pri_lea;
  //printf("\n not_cal_deep");
  //  if	(
  //	 i_pro_sim_max_sup!= i_pro_act+2
  //	 ||
  //	 i_pro_sim_max_inf!= i_pro_act+2
  //	 )
  //  {
      aff_cal_en_cou(i_not_cpt_mvt_ini,2);
 
      //   }
  
  /* interuption de la simulation si mat detecté */
  /* bug: shoud also test the note */
  if (pts_hst_pro_p->defv_mat == Y) sto_sim();

  /* increment du compteur de mouvement */
  //i_not_cpt_mvt_ini++;
  //transfert in pie_sui

}


void tra_don (enum e_sit_typ_not_pos e_sit_typ)
{
  /* Traitement des donnes pour evaluation du meilleur coup */
  int cpt_mvt;
  enum typ_not  cpt_typ_not;
  int i_cam;
  int i_cam_adv;
  ST_NOT_MVT_INI *pts_mvt;

  i_cam 	=ts_hst_pro[i_pro_act+1].i_cam;
  i_cam_adv 	=ts_hst_pro[i_pro_act+1].i_cam_adv;

  /* évaluation de la situation */
  eva_sit(i_cam,i_cam_adv);
	

  /* traitement des données collectées dans hst */
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
      pts_mvt = &ts_not_mvt_ini[cpt_mvt];


      /* cumule valeurs  profondeur	  	*/
      /* calcul différence pc - ca		*/
      /* memorisation mini maxi     		*/
      
      /*dans ce cas seulement  ne pondere pas le nombre de mvt par lui même */
      cum_not(nbr_mvt,pts_mvt);
      
      cum_not_pon(nbr_mat,pts_mvt);
      cum_not_pon(nbr_mat_inc,pts_mvt);
      cum_not_pon(nbr_pat,pts_mvt);
      cum_not_pon(nbr_pat_inc,pts_mvt);
      cum_not_pon(nbr_mat_rf,pts_mvt);
      cum_not_pon(nbr_pat_rf,pts_mvt);
      cum_not_pon(nbr_fou,pts_mvt);
      
      /* calcul couverture et répétition situation  */
      cal_cou_rep(pts_mvt);
		
      /* clacul de la mobilité */
      cal_mob(pts_mvt);     
 
      /* calcul de la  note position*/
      cal_pos(pts_mvt,e_sit_typ);

	 
    } /* fin de la boucle cpt mvt initial */

  /* calcul des notes recadrées */
  for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
    {
      rec_not_mvt(cpt_typ_not);
    }
}
void cal_cou_rep (ST_NOT_MVT_INI *pts_mvt)
{
/* calcul de la couverture et répétitin situation */
  int i_msg;
  //printf("eva:cal_cou_rep %c",);
  /* deplace la piece */
  i_msg = jou (
       pts_mvt->i_pos_ori_n,
       pts_mvt->i_pos_arr_n,
       pro_pio_tra_tmvt_tpie (pts_mvt->i_typ_mvt)
       ) ;
  if(i_msg<0)
    { 	
      printf("\n%c:",pro_pio_tra_tmvt_lpie (pts_mvt->i_typ_mvt));
      printf(" %s",tc_lib_cas[pts_mvt->i_pos_ori_n]);
      printf("%s",tc_lib_cas[pts_mvt->i_pos_arr_n]);
      aff_mes_uti(i_msg);
      return;
    }
  else
    {   
 
      /* sauvegarde du nombre de répétition de situation d'echiquier */
      pts_mvt->i_nbr_rep_sit  = ctl_rep_pos(i_pro_act);
   	
      /* calcul couverture */
      pts_mvt->tst_not[cou_pie].f_not_cam_pon[BLANC] = eva_cou_cam(BLANC);
      pts_mvt->tst_not[cou_pie].f_not_cam_pon[NOIR ] = eva_cou_cam(NOIR );
      cal_dif_max(cou_pie,pts_mvt);

      /*restore la piece */ 
      ann_cou();
    }
  return;
}
void cal_mob (ST_NOT_MVT_INI *pts_mvt)
{
  float mob1,mob2;
  /* calcul de la mobilité par camp */
  
 
  mob1= tst_pro_sta[pts_mvt->i_num_mvt][0].f_dat_pro[nbr_mvt];
  if ( mob1 != 0)
    mob2 =  tst_pro_sta[pts_mvt->i_num_mvt][1].f_dat_pro[nbr_mvt]
      / 
      mob1;
                                          
  else 
    mob2 =0;

  pts_mvt->tst_not[mob_pie].f_not_cam_pon[ tst_pro_sta[pts_mvt->i_num_mvt][0].i_cam]
    = mob1;
  pts_mvt->tst_not[mob_pie].f_not_cam_pon[ tst_pro_sta[pts_mvt->i_num_mvt][1].i_cam]
    = mob2;

  cal_dif_max(mob_pie,pts_mvt);

}
static void cal_pos (ST_NOT_MVT_INI *pts_mvt,enum e_sit_typ_not_pos e_sit_typ)
{

  /* */

  ptptdef_not_pos ptptdef_not_pos; /* the table specific to the piece */
  struct st_pie *pts_pie;          /* pointer on the piece */
  char c_not;                      /* mark (note) for this position after moving  */  
  int i_pos;                       /* recalculated position depending on side color */


  /* get the piece */
  pts_pie= tpts_pie[pts_mvt->i_cam]+pts_mvt->i_Id; 

  /* get the data for this piece */
  ptptdef_not_pos= pts_pie->ptptdef_not_pos_pie;

  /* thereis no table for each side */
  /* each is described for the white side */

  if (pts_mvt->i_cam == BLANC)
    i_pos = pts_mvt->i_pos_arr_n;
  else
    /* black table is symetrical to the white */
    i_pos = 99-pts_mvt->i_pos_arr_n;


  /* get the note for this position */
  c_not=(*ptptdef_not_pos + e_sit_typ)[i_pos];
 
  /*  
 if(pts_pie->c_typ_pie == 'P')
    {
      printf("\n_ptptdef_not_pos %d",  ptptdef_not_pos); 
      printf("\n\t_tptdef_not_pos %d", *ptptdef_not_pos); 
      printf("\n\t\t_e_sit_typ %i",e_sit_typ); 
      printf("\n\t\t_tptdef_not_pos + e_sit_typ %d", *ptptdef_not_pos+e_sit_typ ); 
      printf("\n\t\t_t_def_not_pos %d",tdef_not_pos_pawn); 
      printf("\n\t\t_t_def_not_pos_open %d",tdef_not_pos_pawn_open); 
      printf("\n\t\t_c_not %i",c_not); 
      printf("\n\t\t_i_pos %i",i_pos); 
    }
  */
  /* compute the note linked to the new place of the new piece position */
  //  pts_mvt->tst_not[pos_pie].f_not_cam_pon[ tst_pro_sta[pts_mvt->i_num_mvt][0].i_cam]
  pts_mvt->tst_not[pos_pie].f_not_cam_pon[ pts_mvt->i_cam_adv]
    = 0;
  
  //  pts_mvt->tst_not[pos_pie].f_not_cam_pon[ tst_pro_sta[pts_mvt->i_num_mvt][1].i_cam]
  pts_mvt->tst_not[pos_pie].f_not_cam_pon[ pts_mvt->i_cam]
    = c_not;
  cal_dif_max(pos_pie,pts_mvt);
 
}
static void cum_not_pon (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)
{
  /* org: revoir nom de fonction */
  /* retraite info provenant de hst_pro et cal différence camp -camp adverse
     zt aussi mise à jour des maxi mini */
  int i_cpt_pro;
  float f_pon;
  int i_cam;
  float f_nbr_mvt;

  /* Raz des cumuls */
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[NOIR ]=0;

   pts_mvt->tst_not[e_typ_not].f_not_cam_bru[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_bru[NOIR ]=0;
  
  for(i_cpt_pro=0;i_cpt_pro <PRO_SIM_INF_MAX; i_cpt_pro++)
    {
      /* Cumul par camp  des données stocké par profondeur  en pondérant
       avec le nombre de mvts de la pronfondeur d'acquisition */
      f_nbr_mvt =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[nbr_mvt];
      if(f_nbr_mvt != 0)
	f_pon =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not]
	  / f_nbr_mvt;
      else
	f_pon=0;

      i_cam =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].i_cam;
      pts_mvt->tst_not[e_typ_not].f_not_cam_pon[i_cam]+=f_pon;

      /* Cumul par camp  des données stocké par profondeur sans pondérer */
      pts_mvt->tst_not[e_typ_not].f_not_cam_bru[i_cam]+=
	 tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not];
    }
  
  cal_dif_max(e_typ_not,pts_mvt);

}
void cum_not (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* retraite info provenant de hst_pro et cal différence camp -camp adverse
     zt aussi mise à jour des maxi mini */
  int i_cpt_pro;
  int i_cam;

  /* Raz des cumuls */
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[BLANC]=0;
  pts_mvt->tst_not[e_typ_not].f_not_cam_pon[NOIR ]=0;
  
  /* Cumul par camp  des données stocké par profondeur  en pondérant */
  for(i_cpt_pro=0;i_cpt_pro < PRO_SIM_INF_MAX; i_cpt_pro++)
    {

      i_cam =  tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].i_cam;
      pts_mvt->tst_not[e_typ_not].f_not_cam_pon[i_cam]+=
	 tst_pro_sta[pts_mvt->i_num_mvt][i_cpt_pro].f_dat_pro[e_typ_not];

    }
  
  cal_dif_max(e_typ_not,pts_mvt);

}

void cal_dif_max (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* Calcul de la difference camp propre  - camp adverse  et mise à jour des maxis */

  /* Calcul de la différence */
  pts_mvt->tst_not[e_typ_not].f_not_dif_pon=
    pts_mvt->tst_not[e_typ_not].f_not_cam_pon[pts_mvt->i_cam]
    -
    pts_mvt->tst_not[e_typ_not].f_not_cam_pon[pts_mvt->i_cam_adv];
  
  /* Mise à jour des maxi mini */
  cal_max(e_typ_not,pts_mvt);

}
void cal_max (enum typ_not e_typ_not,ST_NOT_MVT_INI *pts_mvt)

{
  /* Mise à jour des maxi mini */
  if ( pts_mvt->tst_not[e_typ_not].f_not_dif_pon > st_eva_sit.tst_int_not[e_typ_not].max)
    st_eva_sit.tst_int_not[e_typ_not].max=  pts_mvt->tst_not[e_typ_not].f_not_dif_pon;    

  if ( pts_mvt->tst_not[e_typ_not].f_not_dif_pon < st_eva_sit.tst_int_not[e_typ_not].min)
    st_eva_sit.tst_int_not[e_typ_not].min=  pts_mvt->tst_not[e_typ_not].f_not_dif_pon;    


}

void rec_not_mvt (enum typ_not e_typ_not)
{
  /* recadrage de la note en fonction des mini maxi */
  int cpt_mvt;
  ST_NOT_MVT_INI *pts_mvt;

  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
		pts_mvt = &ts_not_mvt_ini[cpt_mvt];

      pts_mvt->tst_not[e_typ_not].i_not_pon_rec 
	=
	rec_not(  st_eva_sit.tst_int_not[e_typ_not].max,
		  st_eva_sit.tst_int_not[e_typ_not].min,
		  pts_mvt->tst_not[e_typ_not].f_not_dif_pon);
 
    }

}
/* recadrage note */ 
int rec_not (float max,float min, float val)
{
  float x = 0;
  x = max-min;
  if (x == 0)
    return 0;
  else
    return (int) ((val-min)/x*100);

}
void  tri_mvt_rec (void)
{
  /* tri en ordre decroissant des mvt selon total recadrée pondéré */
  int cpt_1,cpt_2;
  ST_NOT_MVT_INI *pts_mvt;

  /* chargement table d'indexe avec adresse mvt */
  for (cpt_1 = 0; cpt_1 < MVT_INI; cpt_1++)
    {
      if (cpt_1 < i_not_cpt_mvt_ini)
	/* pointeur sur mouvement courant*/
	ts_tri_mvt_ini[cpt_1].pts_tri_rec = &ts_not_mvt_ini[cpt_1];
      else
	ts_tri_mvt_ini[cpt_1].pts_tri_rec = NULL;

    }
  /* tri décroissant  des mvt avec note recadrée pondérée totale */ 
  for (cpt_1 = 0; cpt_1 < i_not_cpt_mvt_ini; cpt_1++)
    {
      for (cpt_2 = cpt_1+1; cpt_2 < i_not_cpt_mvt_ini; cpt_2++)
	{
	  if(
	     ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_not_pri
	     <
	     ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_not_pri
	     ||
	     (
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_not_pri
	      ==
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_not_pri
	      &&
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->f_tot_rec_pon 
	      <
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->f_tot_rec_pon
	      ) 
	     )
	    {
	      pts_mvt= ts_tri_mvt_ini[cpt_2].pts_tri_rec;
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec=ts_tri_mvt_ini[cpt_1].pts_tri_rec;
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec=pts_mvt;
	    }
	}
    }
}

void  tri_mvt_rec_2 (void)
{
  /* tri en ordre decroissant des mvt selon total recadrée pondéré */
  int cpt_1,cpt_2;
  ST_NOT_MVT_INI *pts_mvt;

  /* chargement table d'indexe avec adresse mvt */
  for (cpt_1 = 0; cpt_1 < MVT_INI; cpt_1++)
    {
      if (cpt_1 < i_not_cpt_mvt_ini)
	/* pointeur sur mouvement courant*/
	ts_tri_mvt_ini[cpt_1].pts_tri_rec = &ts_not_mvt_ini[cpt_1];
      else
	ts_tri_mvt_ini[cpt_1].pts_tri_rec = NULL;

    }
  /* tri décroissant  des mvt avec note recadrée pondérée totale */ 
  for (cpt_1 = 0; cpt_1 < i_not_cpt_mvt_ini; cpt_1++)
    {
      for (cpt_2 = cpt_1+1; cpt_2 < i_not_cpt_mvt_ini; cpt_2++)
	{
	  if(
	     ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_typ_mvt_pri_lea
	     >
	     ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_typ_mvt_pri_lea
	     ||
	     (
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_typ_mvt_pri_lea
	      ==
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_typ_mvt_pri_lea
	      &&
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_not_pri
	      <
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_not_pri
	      ) 
	     ||
	     (
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_typ_mvt_pri_lea
	      ==
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_typ_mvt_pri_lea
	      &&
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->i_not_pri
	      ==
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->i_not_pri
	      &&
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec->f_tot_rec_pon 
	      <
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec->f_tot_rec_pon
	      ) 
	     )
	    {
	      pts_mvt= ts_tri_mvt_ini[cpt_2].pts_tri_rec;
	      ts_tri_mvt_ini[cpt_2].pts_tri_rec=ts_tri_mvt_ini[cpt_1].pts_tri_rec;
	      ts_tri_mvt_ini[cpt_1].pts_tri_rec=pts_mvt;
	    }
	}
    }
}

void pon_not(void)
{
  /* org: nom mal choisi car confusion avec pondération par nbr mvt 
     dans ce cas on pondere avec coeficiant */
  int cpt_mvt;
  ST_NOT_MVT_INI *pts_mvt;

  int pon_tot	=0;
  float tot_rec	=0;
  float tot_dif	=0;
  int cpt_typ_not;

  /* cumul des coeficient */
  for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
    pon_tot+=abs(st_eva_sit.ti_coe_pon[cpt_typ_not]) ;

  /* cumul des notes pondérées */
  for (cpt_mvt = 0; cpt_mvt < i_not_cpt_mvt_ini; cpt_mvt++)
    {
      /* pointeur sur mouvement courant */
      pts_mvt = &ts_not_mvt_ini[cpt_mvt];

      {
	tot_dif=0;
	tot_rec=0;
	for(cpt_typ_not=0;cpt_typ_not<NBR_TYP_NOT;cpt_typ_not++)
	  {
	    tot_dif  += (float) pts_mvt->tst_not[cpt_typ_not].f_not_dif_pon
	                 *
	                 (float) st_eva_sit.ti_coe_pon[cpt_typ_not];

	    tot_rec  += (float) pts_mvt->tst_not[cpt_typ_not].i_not_pon_rec
	                 *
	                (float) st_eva_sit.ti_coe_pon[cpt_typ_not];

	  }
	if(pon_tot !=0 )
	  {
	    pts_mvt->f_tot_dif_pon = (float)	(tot_dif  / (float) pon_tot);
	    pts_mvt->f_tot_rec_pon = (float)	(tot_rec  / (float) pon_tot);
	  }
	else
	  {
	    pts_mvt->f_tot_dif_pon = 0;
	    pts_mvt->f_tot_rec_pon = 0;
	  }
      }
    }
}

void eva_sit(int i_cam, int i_cam_adv)
{
/* rapport de force */
	st_eva_sit.ti_tot_for[BLANC] = eva_for_cam(BLANC);
	st_eva_sit.ti_tot_for[NOIR ] = eva_for_cam(NOIR );
	st_eva_sit.i_not_for = st_eva_sit.ti_tot_for[i_cam] -st_eva_sit.ti_tot_for[i_cam_adv];
/* couverture des pieces */
	st_eva_sit.tf_cou[BLANC]=eva_cou_cam(BLANC);
	st_eva_sit.tf_cou[NOIR] =eva_cou_cam(NOIR);
	st_eva_sit.f_cou = st_eva_sit.tf_cou[i_cam] -st_eva_sit.tf_cou[i_cam_adv];

}
int  eva_for_cam(int i_cam)
{
  int i_for =0;
  struct st_pie  *pts_pie_eva;      	/* ptr sur tbl structure piece */


  pts_pie_eva = tpts_pie[i_cam];
  pts_pie_eva =  tpts_pie[i_cam]+pts_pie_eva->i_pie_sui;

	/* Cumul la force de chaque piece i_tot_for */
  while (1)
	 {
		i_for +=pts_pie_eva->i_for;
		if(pts_pie_eva->i_pie_sui ==17) break;
		pts_pie_eva =tpts_pie[i_cam]+pts_pie_eva->i_pie_sui;
	 }
  return i_for;
}

float eva_cou_cam (int i_cam)
{
  struct st_pie *pts_pie_ct;
  float i_cou_glo = 0;      
 /* Couverture globale*/
 /* calcul couverture part piece propre cam */
  pts_pie_ct=tpts_pie[i_cam] ;

  for (pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
		 ;
		 pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)

	 {
		if (pts_pie_ct->c_typ_pie != 'R')
	i_cou_glo = i_cou_glo +  eva_cou_pie (pts_pie_ct->i_pos_n,i_cam );

		if (pts_pie_ct->i_pie_sui==17) break;

	 }

  return i_cou_glo;
}
float eva_cou_pie (int nn,int i_cam)
{
  struct st_pie *pts_pie_ct;
  float i_cou =0 ;
  int i_cou_ok=0;   /* si au moins une piece couvre la position */

  /* calcul couverture de la piece en position nn
	  par les pieces du camp  du camp  i_cam */
  pts_pie_ct=tpts_pie[i_cam] ;


  for (pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
		 ;
		 pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)

	 {
		if(   (*pts_pie_ct->pf_ctl_par) (pts_pie_ct->i_pos_n,nn )   )
	{
	  /* si piece couverte par au moins une piece on augment la note de couverture
		  de la force de la piece couverte pour favoriser la couverture des pieces
		  les plus importantes*/
	  /* on augmente la note de l'inverse de la force de la piece faisant la couverture
		  pour favoriser la couverture par des pièces de moindre importance */
	  if(pts_pie_ct->i_for != 0)
		 {
			i_cou =i_cou + (float)1/(float)pts_pie_ct->i_for;
			i_cou_ok =1;
		 }
	}
		if (pts_pie_ct->i_pie_sui==17) break;

	  }
  if(i_cou_ok )
		 {
			i_cou += (tpts_pie[ts_ech[nn].i_cam]+ts_ech[nn].i_Id)->i_for;
		 }

  return i_cou;
}
void  seed_ran_cho (void)
{
/* initialisze  the rand function  */

  unsigned  seed_nbr;
  time_t tt;
  struct tm *t;
  time(&tt);
  t=localtime(&tt);
  seed_nbr=t->tm_sec * t->tm_min * t->tm_hour;
  
  srand(seed_nbr);

}
struct st_ver * get_ver_dta(int i_num_ver)
{
  if (i_num_ver < sizeof(tst_ver))
    return &tst_ver[i_num_ver];
  else
    return NULL;

}

unsigned  sel_ran_cho (int u_bas)
{
  /* return a random integer between 1 (included) and u_bas (included) 
     exemple:
     u_bas < 0 --> return 1
     u_bas = 0 --> return 1
     u_bas = 1 --> return 1
   
     u_bas = 2 --> return 1 or 2 
     u_bas = 3 --> return 1 or 2 or 3 
     u_bas = 4 --> return 1 or 2 or 3 or 4

  */
  
  unsigned  x;
  double  y;
  long r;
  if (u_bas <= 1) return 1;

  r=rand();
  y= r / (RAND_MAX +1.0);
  x= (int)(u_bas * y);
  //printf ("\nrandom base %u cho %u rmax/rand %f rand %li randmax %i",u_bas,x,y,r,RAND_MAX);
  return x+1;
}
int ctl_ega (enum e_sit_typ_not_pos e_sit_typ)
{
  // ca aussi c'est pas bon! cas ou il ne reste qu'une reine et quelque pions.
#define LOOSY(a) a<= - (FOR_REI + FOR_TOU)
#define WINNY(a) a>=  (FOR_REI + FOR_TOU)
#define BALANCED(a) a> -(FOR_REI + FOR_TOU) &&  a<(FOR_REI + FOR_TOU)

  unsigned x,y;

  unsigned ti_num_mvt_ini[RANDOM_CHOICE_MAX];

  int i_ran_cho_w;
  struct st_ver *pst_ver;
  extern struct st_ver * get_ver_dta (int i_ver);

 /* if mat is possible do it  */
  if ( (ts_tri_mvt_ini[0].pts_tri_rec)->i_not_pri >=NOT_MAT_MIN)
    return  (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;

  /*if a sure high gain is possible  do it */ 
  if ( 
      (ts_tri_mvt_ini[0].pts_tri_rec)->i_not_pri >=FOR_PIO
      &&
      !(ts_tri_mvt_ini[0].pts_tri_rec)->i_typ_mvt_pri_lea
      )
    return  (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;


  /* find the game-difficulty-level table */
  pst_ver=get_ver_dta(i_ver_eva);
  /* do we choose to use a random solution? */
  if (i_ran_cho)
    {

      switch (e_sit_typ)
	{
	case opn_gam:
	  { 
	    i_ran_cho_w=pst_ver->i_ran_cho_max;
	  }
	  break;
	default:
	  { 
	    i_ran_cho_w=1;
	  }
	  break;
	}
      
    }
  else
	    i_ran_cho_w=1;

  /* debug */
  //printf("i_ran_cho_w %i:",i_ran_cho_w);

  /*  if high probality to loose  */
if (LOOSY(st_eva_sit.i_not_for))
    {
       /* no random chose if high probability to loose */
      i_ran_cho_w=1;
    }
  else
    {
      if(i_ran_cho_w >RANDOM_CHOICE_MAX)    i_ran_cho_w=RANDOM_CHOICE_MAX;
      else
	if(i_ran_cho_w <1)                    i_ran_cho_w=1;
    }

  /*  if high probality to loose  */
  if (LOOSY(st_eva_sit.i_not_for))
    {
            /* see if repetition is possible*/ 
     for(x=0;x<i_not_cpt_mvt_ini  ;x++)
	{
	  if ( (ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit >=1  )
	      return (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
	  else
	    continue;
	}
    }

 
  /* if it's possible to globally gain some pieces   */
  for(x=0;x<i_not_cpt_mvt_ini && (ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri>0 ;x++)
    {
      if (
	  (ts_tri_mvt_ini[x].pts_tri_rec)->i_typ_mvt_pri
	  &&
	  (ts_tri_mvt_ini[x].pts_tri_rec)->i_typ_mvt_pri_lea
	  )
	/* avoid to begin immediately with a taken when the gain isn't sure */
	continue;
      else
	return  (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
    }
  /* no sure gain can be done: extract  sure note=0, eventually a random choice*/
  /* that could modified depending on the other mvs: how many  are positiv and not sure? */
  for(
      x=0,y=0;
      (x<i_not_cpt_mvt_ini) 
	&& 
	y <= (i_ran_cho_w -1) 
		&&
	(ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri==0
	;
      x++
      )
    {
      // if ((ts_tri_mvt_ini[x].pts_tri_rec)->i_not_pri<0)break;

      if (
	  (ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit >1
	  ||
	  (
	   (ts_tri_mvt_ini[x].pts_tri_rec)->i_typ_mvt_pri
	   ||
	   (ts_tri_mvt_ini[x].pts_tri_rec)->i_typ_mvt_pri_lea
	   )
	  )
	{
	  // debug : 
	  //printf("\nctlega:pass  mvt:%i",x);
	continue;
	}
      else
	{  
	  // debug : 
	  //printf("\nctlega:select :%i",x);
	  ti_num_mvt_ini[ y++]=(ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
	  /* debug */
	  // printf("\ny=%i,i_ran_cho_w=%i",y,i_ran_cho_w);
	}
    }
  if (y>0)
    {
      /* y = 0 nothing found 
	 y = 1 one solution in [0]
	 y = 2 two solution in [0] and [1]
	 .....
      */
      return ti_num_mvt_ini[ sel_ran_cho(y)-1];
    }
  /* try the move with the sure  lower loss  */ 
  /* doesn't work in some case try the best note   */

  for(x=0;x<i_not_cpt_mvt_ini ;x++)
    {
      if (
	  (ts_tri_mvt_ini[x].pts_tri_rec)->i_nbr_rep_sit >1
	  /*
	  ||
	  (
	   (ts_tri_mvt_ini[x].pts_tri_rec)->i_typ_mvt_pri
	   &&
	   (ts_tri_mvt_ini[x].pts_tri_rec)->i_typ_mvt_pri_lea
	  )
	  */
	 )
	/* avoid to begin immediately with a taken when not sure of result */
	continue;
      else
	return  (ts_tri_mvt_ini[x].pts_tri_rec)->i_num_mvt;
    }
    return  (ts_tri_mvt_ini[0].pts_tri_rec)->i_num_mvt;
 }

void ini_pos (int i_pro)
{
  int i_num_pie;
  for (i_num_pie=0;i_num_pie<17;i_num_pie++)
    {
      tst_pos[i_pro].i_pos_n[BLANC][i_num_pie] =0;
      tst_pos[i_pro].i_pos_n[NOIR ][i_num_pie] =0;
    } 
  tst_pos[i_pro].ti_roc_cam_typ[BLANC][PET_ROC]=0;
  tst_pos[i_pro].ti_roc_cam_typ[BLANC][GRA_ROC]=0;
  tst_pos[i_pro].ti_roc_cam_typ[NOIR ][PET_ROC]=0;
  tst_pos[i_pro].ti_roc_cam_typ[NOIR ][GRA_ROC]=0;

  tst_pos[i_pro].i_nbr_pie[BLANC]=0;
  tst_pos[i_pro].i_nbr_pie[NOIR ]=0;
  tst_pos[i_pro].i_nbr_pie_tot= 0;

  tst_pos[i_pro].i_som_pos[BLANC]=0;
  tst_pos[i_pro].i_som_pos[NOIR ]=0;
  tst_pos[i_pro].i_som_pos_tot=0;

}

void sav_pos (int i_pro)
{  

  ini_pos(i_pro);

  sav_pos_pie(i_pro,BLANC);		       
  sav_pos_pie(i_pro,NOIR );

  tst_pos[i_pro].i_nbr_pie_tot = 
    tst_pos[i_pro].i_nbr_pie[BLANC]  +  tst_pos[i_pro].i_nbr_pie[NOIR];
  
  tst_pos[i_pro].i_som_pos_tot = 
    tst_pos[i_pro].i_som_pos[BLANC]  +  tst_pos[i_pro].i_som_pos[NOIR];

  tst_pos[i_pro].i_cam_jou = ts_hst_pro[i_pro].i_cam_adv;

  tst_pos[i_pro].ti_roc_cam_typ [0][0] =ts_hst_pro[i_pro+1].ti_roc_cam_typ [0][0];
  tst_pos[i_pro].ti_roc_cam_typ [0][1] =ts_hst_pro[i_pro+1].ti_roc_cam_typ [0][1];
  tst_pos[i_pro].ti_roc_cam_typ [1][0] =ts_hst_pro[i_pro+1].ti_roc_cam_typ [1][0];
  tst_pos[i_pro].ti_roc_cam_typ [1][1] =ts_hst_pro[i_pro+1].ti_roc_cam_typ [1][1];
  
}
void sav_pos_pie (int i_pro, int i_cam)
{
  struct st_pie *pts_pie_ct;
  pts_pie_ct=tpts_pie[i_cam] ;
  
 
  for (pts_pie_ct= pts_pie_ct + pts_pie_ct ->i_pie_sui;
       ;
       pts_pie_ct=tpts_pie[i_cam]+ pts_pie_ct->i_pie_sui)
    
    {
      tst_pos[i_pro].i_pos_n [i_cam][pts_pie_ct->i_Id]  
	=pts_pie_ct->i_pos_n;

      tst_pos[i_pro].i_nbr_pie[i_cam]++;
      tst_pos[i_pro].i_som_pos[i_cam] 
	+= pts_pie_ct->i_pos_n;	
      if (pts_pie_ct->i_pie_sui==17) break;
    }
}
int ctl_rep_pos (int i_pro)
{
  int i_cpt;    		/* compteur profondeur */
  int i_nbr_pos=0;		/* Nombre de positions égales trouvées */

  for (i_cpt= i_pro-1;i_cpt>=0;i_cpt--)
    {
      /* Si le nombre de piece a change: il est inutile de continuer */
      if ( tst_pos[i_pro].i_nbr_pie_tot != tst_pos[i_cpt].i_nbr_pie_tot )	return i_nbr_pos;
     
      /* Vérifie si les positions  sont égales */
      if (
	  tst_pos[i_pro].i_cam_jou == tst_pos[i_cpt].i_cam_jou 
	  && 
	  tst_pos[i_pro].i_som_pos_tot == tst_pos[i_cpt].i_som_pos_tot
	  &&
	  tst_pos[i_pro].ti_roc_cam_typ[0][0] == tst_pos[i_cpt].ti_roc_cam_typ[0][0] 
	  &&
	  tst_pos[i_pro].ti_roc_cam_typ[0][1] == tst_pos[i_cpt].ti_roc_cam_typ[0][1] 
	  &&
	  tst_pos[i_pro].ti_roc_cam_typ[1][0] == tst_pos[i_cpt].ti_roc_cam_typ[1][0] 
	  &&
	  tst_pos[i_pro].ti_roc_cam_typ[1][1] == tst_pos[i_cpt].ti_roc_cam_typ[1][1] 
	  &&
	  ctl_rep_pos_pie(i_pro,i_cpt)
	  )
	i_nbr_pos++;
    }
  return i_nbr_pos;
}
int ctl_rep_pos_pie (int i_pro_act, int i_pro)
{
  int i_Id;    		/* Id de la piece  */
  for(i_Id=1;i_Id<17;i_Id++)
    {
      if (
	  tst_pos[i_pro_act].i_pos_n[BLANC][i_Id]!=tst_pos[i_pro].i_pos_n[BLANC][i_Id]
	  ||
	  tst_pos[i_pro_act].i_pos_n[NOIR ][i_Id]!=tst_pos[i_pro].i_pos_n[NOIR ][i_Id]
	  )
	return 0; /* les traits ne sont pas égaux */
    }
  return 1;
}
/*
void cho_ver (void)
{
  extern struct st_ver * get_ver_dta(int i_ver);
  struct st_ver *pst_ver;
  int i_ver;
  scanf("%i",&i_ver);
  if (i_ver < sizeof(tpf_eva)
      &&
      i_ver>=0
      )
    {
      i_ver_eva = i_ver;

      pst_ver=get_ver_dta(i_ver);

      pf_eva = pst_ver->pf_eva;

      cho_niv(pst_ver->i_pro_sim_niv,pst_ver->i_pro_sim_inc);

      // printf("\n Change version to: %i",i_ver_eva);
    }
  else
    printf (_("\nDoesn't exist"));

}
*/
void cho_ver2 (int i_ver)
{
  struct st_ver *pst_ver;
  extern struct st_ver * get_ver_dta(int i_ver);
 
      i_ver_eva = i_ver;

      pst_ver=get_ver_dta(i_ver);
      if(pst_ver!= NULL)
	{
	  pf_eva = pst_ver->pf_eva;
	  //  cho_niv(pst_ver->i_pro_sim_niv,pst_ver->i_pro_sim_inc);
	  i_pro_sim_niv =pst_ver->i_pro_sim_niv;
	  i_pro_sim_inc =pst_ver->i_pro_sim_inc;
	}
      else
	printf (_("\nDoesn't exist"));

}

/* verifie existance mvt ini */
int ver_exi_mvt_ini(int i_mvt_ini,struct st_evaluation *pst_eva)
{
  if(i_mvt_ini <0 || i_mvt_ini >= pst_eva->i_number_of_initial_move)
   
    /* Mouvement inexistant */
    return -MSG_EXI_MVT_INI_NON;

  else 

    return 0;			
}
