/* 
    Chess-Ec      Copyright (C)   2001-2008 Marc Dechico


    ec_menu.c : Teletyp interface to let the user play
    
     
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  
    
*/
#include "ec_menu.h"


/*  Menu de commande                                                         */

void mnu_cde (void)
{
#define CDE_LEN 80
  char tc_com[ CDE_LEN];
	
  int i_msg=0;              /* message retour de fonction */



  /* initialisation programme */
  ini_pgm();
  e_cur_aff=e_pas_aff;

  printf("%s",tc_sep_tir);
	
  aff_ech(i_cot_aff);

  while (1)
    {
      char c;
      fflush(stdin);
      defv_aff_cal_cou = Y;

      prt_foo(i_pro_act,i_pro_sim_niv,i_pro_sim_inc);

      sai_com(tc_com);

      /* if the commande is a new commande */
      if(new_menu(tc_com))
	{
	  continue;
	}

      c=tolower(tc_com[0]);
	
      if (c== '+')
	{
	  if (strlen(tc_com)==1)
	    {
	      i_msg= aff_nex_pag(&st_evaluation);
	      if(i_msg<0)	
		aff_mes_uti(i_msg);
	      else   
		continue;
	    }
	}
 
      if (c == '-')
	{
	  if (strlen(tc_com)==1)
	    {
	      i_msg= aff_pre_pag(&st_evaluation);
	      if(i_msg<0)	
		aff_mes_uti(i_msg);
	      else   
		continue;
	    }
	}

      if (c ==  (char) *(_("CDE_p")+4) )
	{
	  mnu_cde_prt(tc_com);
	  continue;
	} 	

      if (c == (char) *(_("CDE_m")+4) )
	{
	  mnu_cde_mov(tc_com);
	  continue;
	}

      if (c == (char) *(_("CDE_b")+4) )
	{
	  if (strlen(tc_com)==1)
	    {
	      i_msg=ann_cou_int();
	      if(i_msg<0)	
		aff_mes_uti(i_msg);
	      else
		aff_ech(i_cot_aff);
	      continue;
	    }
	}

      if (c == (char) *(_("CDE_r")+4) )
	{
	  mnu_cde_rec(tc_com);
	  continue;
	}

      if (c == (char) *(_("CDE_s")+4) )
	{
	  if (strlen(tc_com)==1)
	    {
	      if(i_cot_aff==0)
		i_cot_aff=1;
	      else
		i_cot_aff=0;
	      aff_ech(i_cot_aff);
	      continue ;
	    }
	}

      if (c == (char) *(_("CDE_l")+4) ) 
	{
	  if (strlen(tc_com)>=4)
	    {
	      i_msg=chg_lvl(tc_com);
	      if (i_msg<0)
		aff_mes_uti(i_msg); /* oraganisation */
	      continue ;
	    }
	}
			
      if (c == (char) *(_("CDE_f")+4) ) 
	{					
	  mnu_cde_fil(tc_com, i_cot_aff);
	  continue;
	}

      if (c == (char) *(_("CDE_n")+4) )
	{
	  if (strlen(tc_com)==1)
	    {
	      ini_pgm();
	      e_cur_aff=e_pas_aff;

	      aff_ech(i_cot_aff);
	      continue;
	    }
	}
		  
      if (c == (char) *(_("CDE_?")+4) )
	{
	if (strlen(tc_com)==1)
	  {
	    new_mnu_hlp();
	    continue;
	  }
	else
	  if (strlen(tc_com)==2
	      &&
	      *(tc_com +1) == (char) *(_("CDE_?")+4)
	      )
	    {
	      mnu_hlp();
	      continue;
	    }
	}

      if (c == (char) *(_("CDE_q")+4) )
	if (strlen(tc_com)==1)
	  {
	    quit_pgm ();
	    return ;
	  }
#ifdef TEST
      if (c == 't')
	{
	  if (strlen(tc_com)==1)
	    {
                  
	      continue;
	    }
	}
 
 #endif

      /* Commande inconnue tapez h pour aide*/
      if(c != '\0')
	cde_inc();
      else
	aff_ech(i_cot_aff);

    }	 
}
int  new_menu(char *tc_com)
{

  int i_msg;
  char tc_dep[3];               		/* case de depart ex:A1 */
  char tc_arr[4];               		/* case d'arrivée ex:B2 ou A8C pour pion en cavalier */


  if (is_mov(tc_com))
    {
      strncpy(tc_dep,&tc_com[0],2);
      strncpy(tc_arr,&tc_com[2],3);
      if(get_turn()==i_side)
	i_msg=jou_int_jou(tc_dep,tc_arr);
      else
	i_msg=jou_int_ctl(tc_dep,tc_arr);

      if (i_msg<0) 
	aff_mes_uti(i_msg);
      aff_ech(i_cot_aff);	
      return 1;
    }


  if (!strcasecmp(tc_com,_("black")))
    {
      /* organization: change the name of the var to i_side */
      /* i_cot_aff should be only used for printing */
      i_cot_aff=NOIR;
      i_side=NOIR;
      if(get_turn()== BLANC)
	{ 
	  i_msg=sim_jou();
	  if(i_msg<0)
	    {
	      aff_mes_uti(i_msg);
	    }	
	}
      aff_ech(i_cot_aff);
  
      return 1;
    }
  if (!strcasecmp(tc_com,_("white")))
    {
      i_cot_aff=BLANC;
      i_side=BLANC;
      if(get_turn()== NOIR)
	{ 
	  i_msg=sim_jou();
	  if(i_msg<0)
	    {
	      aff_mes_uti(i_msg);
	    }	
	}
      aff_ech(i_cot_aff);
        return 1;
    }
  if (!strcasecmp(tc_com,_("retract")))
    {
      //e_cur_aff=e_pas_aff;
	  
      if( get_turn() == i_side)
	{
	      i_msg=ann_cou_int();
	      if (i_msg >=0)
	      ann_cou_int();
	}
      else
	      i_msg=ann_cou_int();

      if(i_msg<0)	
	aff_mes_uti(i_msg);
      else
	aff_ech(i_cot_aff);
      return 1;
    }
  if (!strcasecmp(tc_com,_("resign")))
    {
      resign();
      return 1;
    }
  extern struct st_ver tst_ver [VER_NBR];
  if (!strcasecmp(tc_com,tst_ver[LOW1].ptc_lib))
    {
      cho_ver2(LOW1);
      return 1;
    }
  if (!strcasecmp(tc_com,tst_ver[MEDIUM1].ptc_lib))
    {
     cho_ver2(MEDIUM1);
      return 1;
    }
  if (!strcasecmp(tc_com,tst_ver[HIGH1].ptc_lib))
    {
     cho_ver2(HIGH1);
      return 1;
    }

  return 0;
}
static void 
mnu_cde_prt(char tc_com[CDE_LEN])
{
  int i_mvt = 0;
  int i_msg = 0;
  char c;
 
  c= tolower (tc_com[1]); 
    
  if ( c ==  (char) *(_("CDE_PRT_h")+8)
       &&
       strlen(tc_com)==2
       )
    {                  
      //e_cur_aff=e_pas_aff;
      aff_hst(i_pro_act,i_pro_sim_max_inf);
      return ;
    }

  if( c ==  '0'
       &&
       strlen(tc_com)==2
      )
    {
      //e_cur_aff=e_pas_aff;
      aff_hst(0,i_pro_act);
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_p")+8)
       &&
       strlen(tc_com)==3
      ) 
    {
      //e_cur_aff=e_pas_aff;
      if (tc_com[2]== '0')
	aff_pie(BLANC);
      else
	aff_pie(NOIR);
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_b")+8)
       &&
       strlen(tc_com)==2
      )
    {
      //e_cur_aff=e_pas_aff;
      aff_ech(i_cot_aff);
      return ;
    }

  if( c ==   (char) *(_("CDE_PRT_m")+8)
       &&
       strlen(tc_com)<=3
      )
    {
      char cc;
      cc = tc_com[2];
  
	
      if( cc ==  '1')
	{  
	  //e_cur_aff=e_aff_not_1;			
	  i_msg=  aff_not_1(&st_evaluation);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);				
	  return ;
	}
      if( cc ==  '2')
	{
	  //e_cur_aff=e_aff_not_2;			
	  i_msg=  aff_not_2(&st_evaluation);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);			    
	  return ;
	}
      else
	{
	  //e_cur_aff=e_aff_not_1;			
	  i_msg=  aff_not_1(&st_evaluation);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);			
	  return ; 
	}
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_i")+8)
       &&
       strlen(tc_com)==3
      )
    {
      //e_cur_aff=e_pas_aff;
      if (isdigit(tc_com[2]))
	i_mvt=atoi(&tc_com[2]);
      i_msg = aff_mvt_ini(i_mvt,&st_evaluation);
      if (i_msg<0) 
	aff_mes_uti(i_msg);			
      return ;
    }
  else
    {    
      cde_inc();
      return ;
    }
}	
static void 
mnu_cde_mov(char tc_com[CDE_LEN])
{
  /* argument p:play et m:move */
  char tc_dep[3];               		/* case de depart ex:A1 */
  char tc_arr[4];               		/* case d'arrivée ex:B2 ou A8C pour pion en cavalier */

  int i_msg=0;
  char c;

  //e_cur_aff=e_pas_aff;
		
  c = tolower (tc_com[1]);
 
  if ( c == (char) *(_("CDE_MOV_m")+8) 
       &&
       strlen(tc_com)==6
       )
    {
      strncpy(tc_dep,&tc_com[2],2);
      strncpy(tc_arr,&tc_com[4],3);
      i_msg=jou_int_jou(tc_dep,tc_arr);
      if (i_msg<0) 
	aff_mes_uti(i_msg);
      aff_ech(i_cot_aff);
      return ;
    }
  if( strlen(tc_com)==5)
    {
      /* mouvement sans reponse de l'ordi */
      strncpy(tc_dep,&tc_com[1],2);
      strncpy(tc_arr,&tc_com[3],3);
      i_msg=jou_int_ctl(tc_dep,tc_arr);
      if (i_msg<0) 
	aff_mes_uti(i_msg);
      aff_ech(i_cot_aff);
      return ;
    }
     	
  cde_inc();
  return;
}

static void 
mnu_cde_rec(char tc_com[CDE_LEN])
{
  int i_msg=0;
  char c;

  // e_cur_aff=e_pas_aff;
  c = tolower (tc_com[1]);

  /* reckon and move */
  if (c == (char) *(_("CDE_REC_m")+8)
      &&
      strlen(tc_com)==2
      )
    {
      i_msg=sim_jou();
      if(i_msg<0)
	{
	  aff_mes_uti(i_msg);
	}	

      aff_ech(i_cot_aff);
      return;
    }
  /* reckon and print */
  if(strlen(tc_com)==1) 
    {
      i_msg=simul_eva(i_pro_sim_niv,
			    i_pro_sim_inc);
      if (i_msg>=0)
	{
	  //e_cur_aff=e_aff_not_1;
	  tst_aff[e_aff_not_1].i_cur_pag=0;
	  i_msg=aff_not_1(&st_evaluation);
	  if (i_msg<0) aff_mes_uti(i_msg);
	}
      else
	aff_mes_uti(i_msg);
      return;	
    }
  cde_inc();
  return;
}

static void 
mnu_cde_fil(char tc_com[CDE_LEN],int i_cot_aff)
{
  int i_msg;
  char c;
  c=tolower (tc_com[1]);

  if ( c == (char) *(_("CDE_FIL_s")+8)
      &&
      strlen(tc_com)==2
       )		
	/* sauvegarde */
    {
      i_msg=sav_dsk("ec.std");
      if(i_msg<0) aff_mes_uti(i_msg);
      return;
    }

  if ( c == (char) *(_("CDE_FIL_l")+8)
      &&
      strlen(tc_com)==2
       )
			/* load */
    {    
// e_cur_aff=e_pas_aff;
    i_msg=rst_dsk("ec.std");
    if (i_msg<0)
      aff_mes_uti(i_msg);
    else
      aff_ech(i_cot_aff);
    return;
    }
  if (c ==  'w'
      &&
      strlen(tc_com)==2
      )	
    /* load  fichier de travail*/
    {
      //e_cur_aff=e_pas_aff;
      i_msg=rst_dsk("ec.wrk");
      if(i_msg<0)
	aff_mes_uti(i_msg);
      else
	aff_ech(i_cot_aff);
      return;
    }
  cde_inc();
  return;
}

static void
prt_foo (int i_pro_act,int i_pro_sim_niv,int i_pro_sim_inc)
{
  struct st_ver *pst_ver;
  extern struct st_ver * get_ver_dta(int i_ver);

  printf("%s",tc_sep_tir);
  if(i_pro_act>0)
    {
      printf("\n");
      /* Mouvement precedent */
      printf( _("Prv_Mvt:") );
      printf("%s",tc_lib_cas[ts_hst_pro[i_pro_act].i_pos_ori_n]);
      printf("%s",tc_lib_cas[ts_hst_pro[i_pro_act].i_pos_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (ts_hst_pro[i_pro_act].i_typ_mvt));
    }
  else
    {
      printf("\n");
    }
   if(ts_hst_pro[i_pro_act+1].i_cam== BLANC)
    /* Tour au blanc */ 
    printf( _("Turn=White") );
  else
    {
      /* tour au noir */
      printf( _("Turn=Black") );
    }
  printf(" ");
  /* Niveau Increment Cote(machine humain)*/
  printf( _("Curr_Deep=%i Simu=%i.%i") ,
	  i_pro_act,
	  i_pro_sim_niv,
	  i_pro_sim_inc
	  );
  /* Print Difficulty level */
  printf(" ");
  extern int i_ver_eva;
  pst_ver=get_ver_dta(i_ver_eva);
  printf(_("Level: %s"),pst_ver->ptc_lib);
  /* Aide:tapez h */  
  printf(" ");
  printf( _("Help:Type ?") );
  printf("\n>");

}
static int 
chg_lvl(char *tc_com)
{
  int cpt,cpt2,str_len;
  char tc_pro_sim[CDE_LEN];
  char tc_pro_sim_inc[CDE_LEN];
  int pro_sim,pro_sim_inc;

  /* extract the first number: the simulation depth */
  cpt2=0;
  for(cpt=1;cpt < CDE_LEN && tc_com[cpt]!='\0'  ;cpt++)
    {
      if (tc_com[cpt]=='.')
	{
	  break;
	}
      else
	{ 
	  if (isdigit(tc_com[cpt]))
	    tc_pro_sim[cpt2++]=tc_com[cpt];
	}
    }
  /* close the string */
  tc_pro_sim[cpt2]='\0';

  /* check that the string representing the number  is correct */
  str_len=strlen( tc_pro_sim);
  if (str_len>0 && str_len<4)
    pro_sim=atoi(tc_pro_sim);
  else
    /*the size of the number doesn't fit */
     return (cho_niv(-1,-1));

 
  /* extract the second number: the simulation depth increment  */

  cpt2=0;
  for(cpt=cpt+1;cpt < CDE_LEN && tc_com[cpt]!='\0' ;cpt++)
    {
      if (isdigit(tc_com[cpt]))
	  tc_pro_sim_inc[cpt2++]=tc_com[cpt];
    }
  /* close the string */
  tc_pro_sim_inc[cpt2]='\0';
  /* check that the string representing the number  is correct */
  str_len=strlen( tc_pro_sim_inc);
  if (str_len>0 && str_len<4)
    pro_sim_inc=atoi(tc_pro_sim_inc);
  else
    /*the size of the number doesn't fit */
     return (cho_niv(pro_sim,-1));
 
  return (cho_niv(pro_sim,pro_sim_inc));


}
/* affichage aide du menu cde  */
static void 
mnu_hlp (void)
{
  printf( _("\nmove                   : m  A7A8N (N only when pawn promoted to Knight)") );
  printf( _("\nmove and move          : mm A7A8C (the computer replys automatically)") );
  printf( _("\nreckon and move        : rm ") );
  printf( _("\nback                   : b  ") );
  printf( _("\nside                   : s (change side black/white)") );
  printf( _("\nlevel (deepness)       : l 4.2") );
  printf( _("\nfile save              : fs (save game)") );
  printf( _("\nfile load              : fl (load game) ") );
  printf( _("\nnew game               : n") );
  printf( _("\nquit                   : q") );
  printf( _("\nreckon and print marks : r") );
  printf( _("\nprint board            : pb") );
  printf( _("\nprint marKs            : pm ") );
  printf( _("\nprint marKs 2          : pm2 ") );
  printf( _("\nprint initial move     : pi 0 (for the first initial move)") );
  printf( _("\nhelp                   : ? ") );

}
/* affichage aide du menu cde  */
static void 
new_mnu_hlp (void)
{
  extern struct st_ver tst_ver [VER_NBR];
 
  printf( _("\nhelp old commandes     : ?? ") );
  printf( _("\nI play black side      : black") );
  printf( _("\nI play white side      : white") );
  printf( _("\nI move my piece        : E2E4") );
  printf( _("\nbeginner level         : %s"),tst_ver[LOW1].ptc_lib);
  printf( _("\nmedium level           : %s"),tst_ver[MEDIUM1].ptc_lib );
  printf( _("\nhigh level             : %s"),tst_ver[HIGH1].ptc_lib );
  printf( _("\nretract last moves     : retract") );
  printf( _("\nresign game            : resign") );
  printf( _("\nnew game               : n") );
  printf( _("\nquit                   : q") );

}
/*  Affichage de l'echiquier */
void 
aff_ech (int i_cam)
{
  int x,y;
  int i_pos_n=0;
  int i_lib_lic;
  char b =' ';       /* Case noire	*/
  char n =' ' ;	      /* Case blanche	*/

  int b_n; /* blanc ou noir: 1 ou -1 */
  char c_lib_pie;

  struct { char *label;}
  tc_lib_lic []=
    {
      {package_string},
      /* TRANSLATORS: limit to 40 char to fit a standard screen */
      {N_("Copyright (C) 2001-2008 Marc Dechico")},
 
      {" "},

      {package_bugreport},     

      {package_www},

      {" "},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("There is ABSOLUTELY NO WARRANTY.")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("This is free software, and you are ")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("welcome to redistribute it under the")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("GNU-Licences terms.See the file COPYING.")},

 

    };


  /* pour les noir  (i_cam = 1) les noir sont en bas */
  if (i_cam==NOIR)
    printf("\n | H | G | F | E | D | C | B | A | ");
  else
    printf("\n | A | B | C | D | E | F | G | H | ");

  printf("    %s",_(tc_lib_lic[0].label));
  printf("\n-+===============================+-");
  printf("    %s",_(tc_lib_lic[1].label));
  i_lib_lic = 2;

  if (i_cam == NOIR)
    {
 
      b_n = 1;

	
      for (y=1;y<=8;y++)

	{	
	
	  b_n *=-1;

	  printf("\n%i",y);
	  for (x=8;x>=1;x--)
	    {
	      i_pos_n = (y*10)+x;
	      if (x<8)
		printf("|");
	      else
		printf(":"); 
	      b_n *=-1;
	
	      if(ts_ech[i_pos_n].i_cam<0)
		{
				  
		  if (b_n > 0) printf(" %c ",b);
		  else 		  printf(" %c ",n);
	
		}
	      else
		{
		  c_lib_pie=
		    (tpts_pie[(ts_ech[i_pos_n].i_cam)]
		     +
		     (ts_ech[i_pos_n].i_Id))->c_lib_pie;
		  if (ts_ech[i_pos_n].i_cam== BLANC)
		    printf("(%c)",c_lib_pie);
		  else
		    printf(" %c ",c_lib_pie);

		}

	    }
	  printf(":%i",y);                                
	  if ((i_lib_lic<=9 && i_pro_act==0)|| i_lib_lic <5) 	    
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));
	  if (y<8)
	    printf("\n-+ - + - + - + - + - + - + - + - +-"); 
	  if ((i_lib_lic<=9 && i_pro_act==0)|| i_lib_lic<5) 
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));

	}
  
    }
  else
    /* pour les blanc (i_cam = BLANC) les blanc sont en bas */
    {


      b_n = 1;
 
      for (y=8;y>=1;y--)
	{
	  b_n *=-1;
	  printf("\n%i",y);
	  for (x=1;x<=8;x++)
	    {
	      i_pos_n= (y*10) + x;
	      if (x>1)
		printf("|");
	      else
		printf(":"); 
	      b_n *=-1;
	
	      if(ts_ech[i_pos_n].i_cam<0)
		{
		  if (b_n > 0) printf(" %c ",b);
		  else 		  printf(" %c ",n);

		}
	      else
		{
		  c_lib_pie=
		    (tpts_pie[(ts_ech[i_pos_n].i_cam)]
		     +
		     (ts_ech[i_pos_n].i_Id))->c_lib_pie;
		  if (ts_ech[i_pos_n].i_cam== BLANC)
		    printf("(%c)",c_lib_pie);
		  else
		    printf(" %c ",c_lib_pie);

		}

	    }
	  printf(":%i",y);
	  if ((i_lib_lic<=9 && i_pro_act==0)|| i_lib_lic<5)
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));
	  if (y>1)
	    printf("\n-+ - + - + - + - + - + - + - + - +-");
	  if ((i_lib_lic<=9 && i_pro_act==0)|| i_lib_lic<5) 
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));

	}
    }
  printf("\n-+===============================+-");
  if (i_cam==NOIR)
    printf("\n | H | G | F | E | D | C | B | A | ");
  else
    printf("\n | A | B | C | D | E | F | G | H | ");


}



void sto_sim_msg(void)
{
  fflush(stdin);
  /* \nVoulez vous interrompre le calcul? (O/N) */
  printf(tc_sep_ast);
  printf("\n");
  printf( _("Dou you want to stop the computation ? (y/n)") );
  printf(tc_sep_ast);
  printf("\n");
  /* getchar();*/
  if( tolower(getchar()) == (char) *(_("y")) )
    sto_sim();
  else
    defv_sto_sim_cla = N;
}

/* Choix remplacement du pion */
/* Verifie si piece de promotion est ok sinon demande interactive */
/* et traduction lib piece vers type piece */

char 
pro_pio_cho_wra (void)
{
  return pro_pio_cho();
}

char pro_pio_cho (void)
{
  int i_msg=0;
  int c;

  /* c=getchar();  bricolage! */
  /* Quelle piece voulez vous pour remplacer le pion? */
  printf(tc_sep_ast);
  printf("\n");
  printf( _("Which piece for the pawn's promotion ? ") );
  printf(tc_sep_ast);
  printf("\n");
      
  while (1)
    {
      fflush(stdin);

      c=getchar();
	  
      i_msg=pro_pio_ver_lib_pie(c);

      if(i_msg>=0)
	return (pro_pio_tra_lpie_tpie(c));
      else
	aff_mes_uti(i_msg);
      printf("\n");
	   
    }
 
}

/* Affichage message utilisateur  */
void aff_mes_uti(int i_mes_num)
{
  /*recupere le texte du message */
  char tc_lib_mes[LEN_MES];
  cha_mes (i_mes_num, tc_lib_mes);
 

  printf("%s",tc_sep_ast);
  printf("\n%s",tc_lib_mes);

  printf("%s",tc_sep_ast);
  printf("\a"); /* alarme */
}
static void sup_blanc(char *tc_str)
{
  /* supprime les blanc de la zone de saisie */
  int i=0;
  int ii=0;
  for(i=0;i<=(int)strlen(tc_str);i++)
    {   
      if(tc_str[i]!=' ')
	{
	  tc_str[ii++]=tc_str[i];
	}
    }
  tc_str[ii]='\0';
}
static void sai_com (char tc_com [80])
{
  int i=0;
  int c;
  
  while(1) 
    {  
      c=getchar();
      
      if (c !=10 && i<78 )
	tc_com[i++]=c;
      else 
	break;
    }	
  tc_com[i]='\0';
  sup_blanc(tc_com);
  return;
}

static void cde_inc (void)
{
  printf(tc_sep_ast );
  printf("\n");
  printf( _("Unknown command type ? for help") );
  printf(tc_sep_ast );
  printf("\a");
}
